Bug 865970 - Review Request: dwlocstat - Tool for examining Dwarf location info coverage
Review Request: dwlocstat - Tool for examining Dwarf location info coverage
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Michael Scherer
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-10-12 19:50 EDT by Petr Machata
Modified: 2015-05-04 21:37 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-12-10 19:37:50 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
misc: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Petr Machata 2012-10-12 19:50:07 EDT
Spec URL: http://pmachata.fedorapeople.org/dwlocstat.spec
SRPM URL: http://pmachata.fedorapeople.org/dwlocstat-0.1-0.1.20121012git4557c3e.fc16.src.rpm

Description: dwlocstat is a tool for examining Dwarf location info coverage.  It
goes through DIEs of given binary's debug info that represent
variables and function parameters.  For each such DIE, it computes
coverage of that DIE's range by location expressions.

Fedora Account System Username: pmachata

$ rpmlint dwlocstat.spec ../RPMS/ppc64/dwlocstat-0.1-0.1.20121012git4557c3e.fc16.ppc64.rpm ../SRPMS/dwlocstat-0.1-0.1.20121012git4557c3e.fc16.src.rpm 
2 packages and 1 specfiles checked; 0 errors, 0 warnings.

I tested the build in Fedora 16 ppc64 mock and Fedora 18 i686 mock (in addition to x86_64 live system).  During the build, you will likely see several messages like this:
error: DIE 1f036: dwarf_getlocation_addr: invalid DWARF. (skipping)

That comes from %check, where I run the program on itself to do elementary smoke testing.  The error messages come from elfutils, which doesn't have support for reading several location expression operators.  A patch implementing this support was upstreamed this week.
Comment 1 Michael Scherer 2012-11-03 10:56:04 EDT
Hi,

it seems there is code from elfutils bundled with it, and while I can see the reason, I think this should be agreed by the FPC, could you see with them ?

( and add the breakdown of the license ). 

Otherwise, everything is good.


Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
[!]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec
[!]: Package contains no bundled libraries. 
There is a copy of some code of elfutils

===== MUST items =====

C/C++:
[x]: Package does not contain any libtool archives (.la)
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[!]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v3 or later)", "Unknown or generated". 2 files have unknown
     license. Detailed output of licensecheck in
     /home/misc/checkout/git/FedoraReview/865970-dwlocstat/licensecheck.txt
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[!]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 51200 bytes in 3 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Uses parallel make.
[x]: SourceX tarball generation or download is documented.
[!]: SourceX / PatchY prefixed with %{name}.
     Note: Source0 (pmachata-dwlocstat-4557c3e.tar.gz)
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: dwlocstat-0.1-0.1.20121012git4557c3e.fc17.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint dwlocstat
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
dwlocstat (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libdw.so.1()(64bit)
    libdw.so.1(ELFUTILS_0.122)(64bit)
    libdw.so.1(ELFUTILS_0.149)(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)



Provides
--------
dwlocstat:
    dwlocstat
    dwlocstat(x86-64)



MD5-sum check
-------------
https://github.com/pmachata/dwlocstat/tarball/4557c3e/pmachata-dwlocstat-4557c3e.tar.gz :
  CHECKSUM(SHA256) this package     : 5a91e26c0a1c909d822239760e4297fde7ffbb2fa3f9dda12ed2587d300f71f0
  CHECKSUM(SHA256) upstream package : 5a91e26c0a1c909d822239760e4297fde7ffbb2fa3f9dda12ed2587d300f71f0


Generated by fedora-review 0.2.0 (Unknown) last change: Unknown
Buildroot used: fedora-17-x86_64
Command line :./try-fedora-review -b 865970
Comment 2 Petr Machata 2012-11-05 08:54:31 EST
(In reply to comment #1)
> it seems there is code from elfutils bundled with it, and while I can see
> the reason, I think this should be agreed by the FPC, could you see with
> them ?

Thanks for review.  I went through the files, and the only actual copy from elfutils is eu-config.h.  This was only used for likely() and unlikely() predicates, and I can live without those, so I dropped eu-config.h.

known-dwarf.h is generated, I think I could hook it into a build process eventually to mirror what's in system dwarf.h, but for now it is unused at all, and I just dropped it.

The .cc and .hh files comprising dwlocstat itself (and dwarfstrings.c/.h as well) grew up on elfutils "dwarf" branch.  But it's very unlikely that this branch will get merged anytime soon (or ever), which is why I split this small tool off to a separate project.  I don't think this counts as embedding a copy, this code never was part of upstream elfutils tarball.

> ( and add the breakdown of the license ). 

I did that now.

The updated SRPM and SPEC are:
http://pmachata.fedorapeople.org/dwlocstat.spec
http://pmachata.fedorapeople.org/dwlocstat-0.1-0.2.20121105gitc55cb50.fc15.src.rpm
Comment 3 Michael Scherer 2012-11-23 08:11:32 EST
Ok so good for me ( sorry to not have approved earlier )
Comment 4 Petr Machata 2012-12-03 15:33:42 EST
New Package SCM Request
=======================
Package Name: dwlocstat
Short Description: Tool for examining Dwarf location info coverage
Owners: pmachata
Branches: f17 f18 
InitialCC:
Comment 5 Gwyn Ciesla 2012-12-03 15:38:09 EST
Git done (by process-git-requests).
Comment 6 Petr Machata 2012-12-10 19:37:50 EST
Thanks for collaboration, everyone.

Note You need to log in before you can comment on or make changes to this bug.